import axios from 'axios';
import dayjs from 'dayjs';
import sinon from 'sinon';

import { DATE_TIME_FORMAT } from '@/shared/composables/date-format';
import { ModelloLiberatoria } from '@/shared/model/modello-liberatoria.model';

import ModelloLiberatoriaService from './modello-liberatoria.service';

const error = {
  response: {
    status: null,
    data: {
      type: null,
    },
  },
};

const axiosStub = {
  get: sinon.stub(axios, 'get'),
  post: sinon.stub(axios, 'post'),
  put: sinon.stub(axios, 'put'),
  patch: sinon.stub(axios, 'patch'),
  delete: sinon.stub(axios, 'delete'),
};

describe('Service Tests', () => {
  describe('ModelloLiberatoria Service', () => {
    let service: ModelloLiberatoriaService;
    let elemDefault;
    let currentDate: Date;

    beforeEach(() => {
      service = new ModelloLiberatoriaService();
      currentDate = new Date();
      elemDefault = new ModelloLiberatoria(123, 'AAAAAAA', 'AAAAAAA', 'image/png', 'AAAAAAA', currentDate, currentDate);
    });

    describe('Service methods', () => {
      it('should find an element', async () => {
        const returnedFromService = {
          validoDal: dayjs(currentDate).format(DATE_TIME_FORMAT),
          validoAl: dayjs(currentDate).format(DATE_TIME_FORMAT),
          ...elemDefault,
        };
        axiosStub.get.resolves({ data: returnedFromService });

        return service.find(123).then(res => {
          expect(res).toMatchObject(elemDefault);
        });
      });

      it('should not find an element', async () => {
        axiosStub.get.rejects(error);
        return service
          .find(123)
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });

      it('should create a ModelloLiberatoria', async () => {
        const returnedFromService = {
          id: 123,
          validoDal: dayjs(currentDate).format(DATE_TIME_FORMAT),
          validoAl: dayjs(currentDate).format(DATE_TIME_FORMAT),
          ...elemDefault,
        };
        const expected = { validoDal: currentDate, validoAl: currentDate, ...returnedFromService };

        axiosStub.post.resolves({ data: returnedFromService });
        return service.create({}).then(res => {
          expect(res).toMatchObject(expected);
        });
      });

      it('should not create a ModelloLiberatoria', async () => {
        axiosStub.post.rejects(error);

        return service
          .create({})
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });

      it('should update a ModelloLiberatoria', async () => {
        const returnedFromService = {
          nome: 'BBBBBB',
          testo: 'BBBBBB',
          documento: 'BBBBBB',
          validoDal: dayjs(currentDate).format(DATE_TIME_FORMAT),
          validoAl: dayjs(currentDate).format(DATE_TIME_FORMAT),
          ...elemDefault,
        };

        const expected = { validoDal: currentDate, validoAl: currentDate, ...returnedFromService };
        axiosStub.put.resolves({ data: returnedFromService });

        return service.update(expected).then(res => {
          expect(res).toMatchObject(expected);
        });
      });

      it('should not update a ModelloLiberatoria', async () => {
        axiosStub.put.rejects(error);

        return service
          .update({})
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });

      it('should partial update a ModelloLiberatoria', async () => {
        const patchObject = {
          nome: 'BBBBBB',
          testo: 'BBBBBB',
          documento: 'BBBBBB',
          validoAl: dayjs(currentDate).format(DATE_TIME_FORMAT),
          ...new ModelloLiberatoria(),
        };
        const returnedFromService = Object.assign(patchObject, elemDefault);

        const expected = { validoDal: currentDate, validoAl: currentDate, ...returnedFromService };
        axiosStub.patch.resolves({ data: returnedFromService });

        return service.partialUpdate(patchObject).then(res => {
          expect(res).toMatchObject(expected);
        });
      });

      it('should not partial update a ModelloLiberatoria', async () => {
        axiosStub.patch.rejects(error);

        return service
          .partialUpdate({})
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });

      it('should return a list of ModelloLiberatoria', async () => {
        const returnedFromService = {
          nome: 'BBBBBB',
          testo: 'BBBBBB',
          documento: 'BBBBBB',
          validoDal: dayjs(currentDate).format(DATE_TIME_FORMAT),
          validoAl: dayjs(currentDate).format(DATE_TIME_FORMAT),
          ...elemDefault,
        };
        const expected = { validoDal: currentDate, validoAl: currentDate, ...returnedFromService };
        axiosStub.get.resolves([returnedFromService]);
        return service.retrieve().then(res => {
          expect(res).toContainEqual(expected);
        });
      });

      it('should not return a list of ModelloLiberatoria', async () => {
        axiosStub.get.rejects(error);

        return service
          .retrieve()
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });

      it('should delete a ModelloLiberatoria', async () => {
        axiosStub.delete.resolves({ ok: true });
        return service.delete(123).then(res => {
          expect(res.ok).toBeTruthy();
        });
      });

      it('should not delete a ModelloLiberatoria', async () => {
        axiosStub.delete.rejects(error);

        return service
          .delete(123)
          .then()
          .catch(err => {
            expect(err).toMatchObject(error);
          });
      });
    });
  });
});
